## ros-galactic-rmw-cyclonedds-cpp 0.22.6

=== CMakeLists.txt ===
# Copyright 2018 ADLINK Technology Limited.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)

project(rmw_cyclonedds_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wimplicit-fallthrough)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(rcutils REQUIRED)
find_package(rcpputils REQUIRED)

#find_package(cyclonedds_cmake_module REQUIRED)
find_package(CycloneDDS QUIET CONFIG)
if(NOT CycloneDDS_FOUND)
  message(WARNING "Could not find Eclipse Cyclone DDS - skipping '${PROJECT_NAME}'")
  ament_package()
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_dds_common REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_typesupport_introspection_c REQUIRED)
find_package(rosidl_typesupport_introspection_cpp REQUIRED)

ament_export_dependencies(rcutils)
ament_export_dependencies(rcpputils)
ament_export_dependencies(rmw)
ament_export_dependencies(rosidl_runtime_c)
ament_export_dependencies(rmw_dds_common)
ament_export_dependencies(rosidl_typesupport_introspection_c)
ament_export_dependencies(rosidl_typesupport_introspection_cpp)

add_library(rmw_cyclonedds_cpp
  src/rmw_get_network_flow_endpoints.cpp
  src/rmw_node.cpp
  src/serdata.cpp
  src/serdes.cpp
  src/u16string.cpp
  src/exception.cpp
  src/demangle.cpp
  src/deserialization_exception.cpp
  src/Serialization.cpp
  src/TypeSupport2.cpp
  src/TypeSupport.cpp)

target_link_libraries(rmw_cyclonedds_cpp
  CycloneDDS::ddsc
)
if(CMAKE_GENERATOR_PLATFORM)
  set(TARGET_ARCH "${CMAKE_GENERATOR_PLATFORM}")
else()
  set(TARGET_ARCH "${CMAKE_SYSTEM_PROCESSOR}")
endif()

if(CMAKE_COMPILER_IS_GNUCXX AND TARGET_ARCH MATCHES "^(riscv|RISCV)64$")
  # using GCC, libatomic is not automatically linked for RISC-V
  target_link_libraries(rmw_cyclonedds_cpp -latomic)
endif()


ament_target_dependencies(rmw_cyclonedds_cpp
  "rcutils"
  "rcpputils"
  "rosidl_typesupport_introspection_c"
  "rosidl_typesupport_introspection_cpp"
  "rmw"
  "rmw_dds_common"
  "rosidl_runtime_c"
)

configure_rmw_library(rmw_cyclonedds_cpp)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    RMW_VERSION_MAJOR=${rmw_VERSION_MAJOR}
    RMW_VERSION_MINOR=${rmw_VERSION_MINOR}
    RMW_VERSION_PATCH=${rmw_VERSION_PATCH}
)

ament_export_libraries(rmw_cyclonedds_cpp)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_introspection_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_introspection_cpp")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

install(
  TARGETS rmw_cyclonedds_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

include(cmake/get_rmw_cyclonedds_output_filter.cmake)
get_rmw_cyclonedds_output_filter(rmw_cyclonedds_output_patterns)
ament_index_register_resource("rmw_output_patterns" CONTENT "${rmw_cyclonedds_output_patterns}")

=== debian/changelog ===
ros-galactic-rmw-cyclonedds-cpp (0.22.6-1focal) focal; urgency=high

  * Handle allocation errors during message deserialization (#418 <https://github.com/ros2/rmw_cyclonedds/issues/418>)
  * Adds topic name to error msg when create_topic fails (#421 <https://github.com/ros2/rmw_cyclonedds/issues/421>)
  * Improve error message when create_topic fails (#407 <https://github.com/ros2/rmw_cyclonedds/issues/407>)
  * Contributors: Jacob Perron, Michel Hidalgo, Shane Loretz, Voldivh

 -- Erik Boasson <erik.boasson@adlinktech.com>  Fri, 02 Dec 2022 08:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.22.5-1focal) focal; urgency=high

  * Free with the same allocator in rmw_destroy_node (#355 <https://github.com/ros2/rmw_cyclonedds/issues/355>) (#368 <https://github.com/ros2/rmw_cyclonedds/issues/368>)
  * Contributors: Jacob Perron

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 28 Apr 2022 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.22.4-1focal) focal; urgency=high

  * Fix use of deprecated is_loan_available (#359 <https://github.com/ros2/rmw_cyclonedds/issues/359>)
  * rmw_cyclonedds_cpp/CMakeLists.txt: add -latomic for RISC-V (#334 <https://github.com/ros2/rmw_cyclonedds/issues/334>)
  * Contributors: eboasson, guillaume-pais-siemens

 -- Erik Boasson <erik.boasson@adlinktech.com>  Wed, 22 Dec 2021 08:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.22.3-1focal) focal; urgency=high

  * Update Galactic to support zero-copy. (#321 <https://github.com/ros2/rmw_cyclonedds/issues/321>)
  * Contributors: eboasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 17 Jun 2021 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.22.2-1focal) focal; urgency=high

  * Fix the history depth for KEEP_ALL. (#305 <https://github.com/ros2/rmw_cyclonedds/issues/305>)
  * Contributors: Chris Lalancette

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 26 Apr 2021 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.22.1-1focal) focal; urgency=high

  * Use the macros from Cyclone DDS to work with sample payload when using SHM (#300 <https://github.com/ros2/rmw_cyclonedds/issues/300>)
  * Contributors: Sumanth Nirmal

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 12 Apr 2021 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.22.0-1focal) focal; urgency=high

  * Add loaned sample zero-copy API support (#297 <https://github.com/ros2/rmw_cyclonedds/issues/297>)
  * Contributors: Sumanth Nirmal

 -- Erik Boasson <erik.boasson@adlinktech.com>  Wed, 07 Apr 2021 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.21.0-1focal) focal; urgency=high

  * Indicate missing support for unique network flows (#282 <https://github.com/ros2/rmw_cyclonedds/issues/282>)
  * Contributors: Ananya Muddukrishna

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 06 Apr 2021 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.20.0-1focal) focal; urgency=high

  * Take and return new RMW_DURATION_INFINITE correctly (#288 <https://github.com/ros2/rmw_cyclonedds/issues/288>)
  * Contributors: Emerson Knapp

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 18 Mar 2021 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.19.0-1focal) focal; urgency=high

  * Add RMW function to check QoS compatibility (#286 <https://github.com/ros2/rmw_cyclonedds/issues/286>)
  * Contributors: Jacob Perron

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 01 Mar 2021 08:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.18.4-1focal) focal; urgency=high

  * Fix use-after-free in error handling bug
  * Drop compatibility with ancient cyclone versions
  * Update to use Cyclone's renamed ddsi_sertype
  * Use init-on-first-use for global state (#275 <https://github.com/ros2/rmw_cyclonedds/issues/275>)
  * Make sure to reset the error when a typesupport can't be found.
  * Switch to using the generic functions for the typesupport handles.
  * Handle typesupport errors on fetch. (#271 <https://github.com/ros2/rmw_cyclonedds/issues/271>)
  * Handle potential divide by 0 (#267 <https://github.com/ros2/rmw_cyclonedds/issues/267>)
  * Fix incorrect log message(rmw_fastrtps_shared_cpp -> rmw_cylonedds_cpp) (#260 <https://github.com/ros2/rmw_cyclonedds/issues/260>)
  * Update maintainers (#254 <https://github.com/ros2/rmw_cyclonedds/issues/254>)
  * Change wrong use of %ld to print std::size_t to %zu
  * Contributors: Chris Lalancette, Erik Boasson, Ivan Santiago Paunovic, Michel Hidalgo, Stephen Brawner, Sven Brinkmann, eboasson, pluris

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 25 Jan 2021 08:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.18.3-1focal) focal; urgency=high

  * Return RMW_RET_UNSUPPORTED in rmw_get_serialized_message_size (#250 <https://github.com/ros2/rmw_cyclonedds/issues/250>)
  * Update service/client request/response API error returns (#249 <https://github.com/ros2/rmw_cyclonedds/issues/249>)
  * Contributors: Alejandro Hernández Cordero, Jose Tomas Lorente

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 29 Sep 2020 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.18.2-1focal) focal; urgency=high

  * Updated publisher/subscription allocation and wait set API return codes (#246 <https://github.com/ros2/rmw_cyclonedds/issues/246>)
  * Contributors: Alejandro Hernández Cordero

 -- Erik Boasson <erik.boasson@adlinktech.com>  Fri, 25 Sep 2020 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.18.1-1focal) focal; urgency=high

  * Fix array get_function semantics (#248 <https://github.com/ros2/rmw_cyclonedds/issues/248>)
  * Update service/client construction/destruction API return codes. (#247 <https://github.com/ros2/rmw_cyclonedds/issues/247>)
  * Contributors: Ivan Santiago Paunovic, Michel Hidalgo

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 24 Sep 2020 07:00:00 -0000

ros-galactic-rmw-cyclonedds-cpp (0.18.0-1focal) focal; urgency=high

  * Update gid API return codes. (#244 <https://github.com/ros2/rmw_cyclonedds/issues/244>)


=== debian/control ===
Source: ros-galactic-rmw-cyclonedds-cpp
Section: misc
Priority: optional
Maintainer: Erik Boasson <erik.boasson@adlinktech.com>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake-ros, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-cyclonedds, ros-galactic-rcpputils, ros-galactic-rcutils, ros-galactic-rmw, ros-galactic-rmw-dds-common, ros-galactic-rosidl-runtime-c, ros-galactic-rosidl-typesupport-introspection-c, ros-galactic-rosidl-typesupport-introspection-cpp, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rmw-cyclonedds-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-cyclonedds, ros-galactic-rcpputils, ros-galactic-rcutils, ros-galactic-rmw, ros-galactic-rmw-dds-common, ros-galactic-rosidl-runtime-c, ros-galactic-rosidl-typesupport-introspection-c, ros-galactic-rosidl-typesupport-introspection-cpp, ros-galactic-ros-workspace
Description: Implement the ROS middleware interface using Eclipse CycloneDDS in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-rmw-cyclonedds-cpp//opt/ros/galactic/lib/:$(CURDIR)/debian/ros-galactic-rmw-cyclonedds-cpp//opt/ros/galactic/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/:/opt/ros/galactic/lib/:/opt/ros/galactic/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
